Index: palm/trunk/SOURCE/radiation_model.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model.f90	(revision 1686)
+++ palm/trunk/SOURCE/radiation_model.f90	(revision 1691)
@@ -857,6 +938,12 @@
        CALL exchange_horiz( rad_lw_in,  nbgp )
        CALL exchange_horiz( rad_lw_out, nbgp )
+       CALL exchange_horiz( rad_lw_hr,    nbgp )
+       CALL exchange_horiz( rad_lw_cs_hr, nbgp )
+
        CALL exchange_horiz( rad_sw_in,  nbgp )
        CALL exchange_horiz( rad_sw_out, nbgp ) 
+       CALL exchange_horiz( rad_sw_hr,    nbgp )
+       CALL exchange_horiz( rad_sw_cs_hr, nbgp )
+
        CALL exchange_horiz_2d( rad_net, nbgp )
 #endif
@@ -897,5 +984,5 @@
 !
 !--    Check if the sun is up (otheriwse shortwave calculations can be skipped)
-       IF ( zenith(0) .GT. 0.0_wp )  THEN
+       IF ( zenith(0) > 0.0_wp )  THEN
           sun_up = .TRUE.
        ELSE
@@ -996,9 +1083,16 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) :: id, id_dim_zrad, id_var, k, nz_snd, nz_snd_start, nz_snd_end
-
-       REAL(wp) :: t_surface
-
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  hyp_snd_tmp, t_snd_tmp
+       INTEGER(iwp) :: id,           & !< NetCDF id of input file
+                       id_dim_zrad,  & !< pressure level id in the NetCDF file
+                       id_var,       & !< NetCDF variable id
+                       k,            & !< loop index
+                       nz_snd,       & !< number of vertical levels in the sounding data
+                       nz_snd_start, & !< start vertical index for sounding data to be used
+                       nz_snd_end      !< end vertical index for souding data to be used
+
+       REAL(wp) :: t_surface           !< actual surface temperature
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  hyp_snd_tmp, & !< temporary hydrostatic pressure profile (sounding)
+                                               t_snd_tmp      !< temporary temperature profile (sounding)
 
 !
@@ -1014,4 +1108,5 @@
           DEALLOCATE ( rrtm_tlay )
           DEALLOCATE ( rrtm_tlev )
+
           DEALLOCATE ( rrtm_h2ovmr )
           DEALLOCATE ( rrtm_cicewp )
@@ -1022,10 +1117,14 @@
           DEALLOCATE ( rrtm_lw_taucld )
           DEALLOCATE ( rrtm_lw_tauaer )
+
           DEALLOCATE ( rrtm_lwdflx  )
+          DEALLOCATE ( rrtm_lwdflxc )
           DEALLOCATE ( rrtm_lwuflx  )
+          DEALLOCATE ( rrtm_lwuflxc )
+          DEALLOCATE ( rrtm_lwuflx_dt )
+          DEALLOCATE ( rrtm_lwuflxc_dt )
           DEALLOCATE ( rrtm_lwhr  )
-          DEALLOCATE ( rrtm_lwuflxc )
-          DEALLOCATE ( rrtm_lwdflxc )
           DEALLOCATE ( rrtm_lwhrc )
+
           DEALLOCATE ( rrtm_sw_taucld )
           DEALLOCATE ( rrtm_sw_ssacld )
@@ -1035,11 +1134,13 @@
           DEALLOCATE ( rrtm_sw_ssaaer )
           DEALLOCATE ( rrtm_sw_asmaer ) 
-          DEALLOCATE ( rrtm_sw_ecaer )    
+          DEALLOCATE ( rrtm_sw_ecaer )   
+ 
           DEALLOCATE ( rrtm_swdflx  )
+          DEALLOCATE ( rrtm_swdflxc )
           DEALLOCATE ( rrtm_swuflx  )
+          DEALLOCATE ( rrtm_swuflxc )
           DEALLOCATE ( rrtm_swhr  )
-          DEALLOCATE ( rrtm_swuflxc )
-          DEALLOCATE ( rrtm_swdflxc )
           DEALLOCATE ( rrtm_swhrc )
+
        ENDIF
 
@@ -1063,5 +1164,5 @@
 !--    Read pressure from file
        nc_stat = NF90_INQ_VARID( id, "Pressure", id_var )
-       nc_stat = NF90_GET_VAR( id, id_var, hyp_snd_tmp(:), start = (/1/),    &
+       nc_stat = NF90_GET_VAR( id, id_var, hyp_snd_tmp(:), start = (/1/),      &
                                count = (/nz_snd/) )
        CALL handle_netcdf_error( 'netcdf', 552 )
@@ -1075,5 +1176,5 @@
 !--    Read temperature from file
        nc_stat = NF90_INQ_VARID( id, "ReferenceTemperature", id_var )
-       nc_stat = NF90_GET_VAR( id, id_var, t_snd_tmp(:), start = (/1/),      &
+       nc_stat = NF90_GET_VAR( id, id_var, t_snd_tmp(:), start = (/1/),        &
                                count = (/nz_snd/) )
        CALL handle_netcdf_error( 'netcdf', 553 )
@@ -1088,5 +1189,5 @@
 !--    in Pa, hyp_snd in hPa).
        DO  k = 1, nz_snd
-          IF ( hyp_snd_tmp(k) .LT. (hyp(nzt+1) - 1000.0_wp) * 0.01_wp )  THEN
+          IF ( hyp_snd_tmp(k) < ( hyp(nzt+1) - 1000.0_wp) * 0.01_wp )  THEN
              nz_snd_start = k
              EXIT
@@ -1094,5 +1195,5 @@
        END DO
 
-       IF ( nz_snd_start .LE. nz_snd )  THEN
+       IF ( nz_snd_start <= nz_snd )  THEN
           nz_snd_end = nz_snd - 1
        END IF
@@ -1128,5 +1229,5 @@
        ALLOCATE ( rrtm_plev(0:0,nzb+1:nzt_rad+2)   )
 
-       t_surface = pt_surface * (surface_pressure / 1000.0_wp )**0.286_wp
+       t_surface = pt_surface * ( surface_pressure / 1000.0_wp )**0.286_wp
        DO k = nzb+1, nzt+1
           rrtm_play(0,k) = hyp(k) * 0.01_wp
@@ -1160,6 +1261,6 @@
           rrtm_h2ovmr(0,k) = q_snd(k)
        ENDDO
-       rrtm_tlay(0,nzt_rad+1)   = 2.0_wp * rrtm_tlay(0,nzt_rad)                &
-                                  - rrtm_tlay(0,nzt_rad-1)
+       rrtm_tlay(0,nzt_rad+1) = 2.0_wp * rrtm_tlay(0,nzt_rad)                 &
+                                - rrtm_tlay(0,nzt_rad-1)
        DO k = nzt+9, nzt_rad+1
           rrtm_tlev(0,k)   = rrtm_tlay(0,k-1) + (rrtm_tlay(0,k)                &
@@ -1237,4 +1338,9 @@
        rrtm_lwhrc   = 0.0_wp
 
+       ALLOCATE ( rrtm_lwuflx_dt(0:0,nzb:nzt_rad+1) )
+       ALLOCATE ( rrtm_lwuflxc_dt(0:0,nzb:nzt_rad+1) )
+
+       rrtm_lwuflxc_dt = 0.0_wp
+       rrtm_lwuflxc_dt = 0.0_wp
 
     END SUBROUTINE read_sounding_data
@@ -1253,11 +1359,19 @@
        IMPLICIT NONE
 
-       INTEGER(iwp), PARAMETER :: num_trace_gases = 9 !< number of trace gases
-
-       CHARACTER(LEN=5), DIMENSION(num_trace_gases), PARAMETER ::              &
+       INTEGER(iwp), PARAMETER :: num_trace_gases = 9 !< number of trace gases (absorbers)
+
+       CHARACTER(LEN=5), DIMENSION(num_trace_gases), PARAMETER ::              & !< trace gas names
            trace_names = (/'O3   ', 'CO2  ', 'CH4  ', 'N2O  ', 'O2   ',        &
                            'CFC11', 'CFC12', 'CFC22', 'CCL4 '/)
 
-       INTEGER(iwp) :: id, k, m, n, nabs, np, id_abs, id_dim, id_var
+       INTEGER(iwp) :: id,     & !< NetCDF id
+                       k,      & !< loop index
+                       m,      & !< loop index
+                       n,      & !< loop index
+                       nabs,   & !< number of absorbers
+                       np,     & !< number of pressure levels
+                       id_abs, & !< NetCDF id of the respective absorber
+                       id_dim, & !< NetCDF id of asborber's dimension
+                       id_var    !< NetCDf id ot the absorber
 
        REAL(wp) :: p_mls_l, p_mls_u, p_wgt_l, p_wgt_u, p_mls_m
@@ -1380,5 +1494,5 @@
 !--          When the pressure level is higher than the trace gas pressure
 !--          level, assume that 
-             IF ( rrtm_plev_tmp(k-1) .GT. p_mls(1) )  THEN             
+             IF ( rrtm_plev_tmp(k-1) > p_mls(1) )  THEN             
                 
                 trace_mls_path(k,m) = trace_mls_path(k,m) + trace_mls(m,1)     &
@@ -1399,5 +1513,5 @@
                           MAX( rrtm_plev_tmp(k), p_mls(n-1) ) )
 
-                IF ( p_mls_l .GT. p_mls_u )  THEN
+                IF ( p_mls_l > p_mls_u )  THEN
 
 !
@@ -1412,9 +1526,9 @@
                                          +  ( p_wgt_u * trace_mls(m,n)         &
                                             + p_wgt_l * trace_mls(m,n-1) )     &
-                                         * (p_mls_l + p_mls_u) / g
+                                         * (p_mls_l - p_mls_u) / g
                 ENDIF
              ENDDO
 
-             IF ( rrtm_plev_tmp(k) .LT. p_mls(np) )  THEN 
+             IF ( rrtm_plev_tmp(k) < p_mls(np) )  THEN 
                 trace_mls_path(k,m) = trace_mls_path(k,m) + trace_mls(m,np)    &
                                       * ( MIN( rrtm_plev_tmp(k-1), p_mls(np) ) &
@@ -1503,40 +1617,19 @@
     SUBROUTINE radiation_tendency_ij ( i, j, tend )
 
-       USE arrays_3d,                                                          &
-           ONLY:  dzw
-
        USE cloud_parameters,                                                   &
-           ONLY:  pt_d_t, cp
-
-       USE control_parameters,                                                 &
-           ONLY:  rho_surface
+           ONLY:  pt_d_t
 
        IMPLICIT NONE
 
-       INTEGER(iwp) :: i, j, k
-
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: tend
+       INTEGER(iwp) :: i, j, k !< loop indices
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: tend !< pt tendency term
 
 #if defined ( __rrtmg )
-
-       REAL(wp) :: rad_sw_net_l, rad_sw_net_u, rad_lw_net_l, rad_lw_net_u
-
-       rad_sw_net_l = 0.0_wp
-       rad_sw_net_u = 0.0_wp
-       rad_lw_net_l = 0.0_wp
-       rad_lw_net_u = 0.0_wp
-
-!
-!--    Calculate radiative flux divergence
+!
+!--    Calculate tendency based on heating rate
        DO k = nzb+1, nzt+1
-
-          rad_sw_net_l = rad_sw_in(k-1,j,i) - rad_sw_out(k-1,j,i)
-          rad_sw_net_u = rad_sw_in(k,j,i)   - rad_sw_out(k,j,i)
-          rad_lw_net_l = rad_lw_in(k-1,j,i) - rad_lw_out(k-1,j,i)
-          rad_lw_net_u = rad_lw_in(k,j,i)   - rad_lw_out(k,j,i)
-
-          tend(k,j,i) = tend(k,j,i) + ( rad_sw_net_u - rad_sw_net_l            &
-                                      + rad_lw_net_u - rad_lw_net_l ) /        &
-                                     ( dzw(k) * cp * rho_surface ) * pt_d_t(k) 
+          tend(k,j,i) = tend(k,j,i) + (rad_lw_hr(k,j,i) + rad_sw_hr(k,j,i))    &
+                                      * pt_d_t(k) * d_seconds_hour
        ENDDO
 
@@ -1554,46 +1647,25 @@
     SUBROUTINE radiation_tendency ( tend )
 
-       USE arrays_3d,                                                          &
-           ONLY:  dzw
-
        USE cloud_parameters,                                                   &
-           ONLY:  pt_d_t, cp
+           ONLY:  pt_d_t
 
        USE indices,                                                            &
            ONLY:  nxl, nxr, nyn, nys
 
-       USE control_parameters,                                                 &
-           ONLY:  rho_surface
-
        IMPLICIT NONE
 
-       INTEGER(iwp) :: i, j, k
-
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: tend
+       INTEGER(iwp) :: i, j, k !< loop indices
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: tend !< pt tendency term
 
 #if defined ( __rrtmg )
-
-       REAL(wp) :: rad_sw_net_l, rad_sw_net_u, rad_lw_net_l, rad_lw_net_u
-
-       rad_sw_net_l = 0.0_wp
-       rad_sw_net_u = 0.0_wp
-       rad_lw_net_l = 0.0_wp
-       rad_lw_net_u = 0.0_wp
-
+!
+!--    Calculate tendency based on heating rate
        DO  i = nxl, nxr
           DO  j = nys, nyn
-
-!
-!--          Calculate radiative flux divergence
              DO k = nzb+1, nzt+1
-
-                rad_sw_net_l = rad_sw_in(k-1,j,i) - rad_sw_out(k-1,j,i)
-                rad_sw_net_u = rad_sw_in(k  ,j,i) - rad_sw_out(k  ,j,i)
-                rad_lw_net_l = rad_lw_in(k-1,j,i) - rad_lw_out(k-1,j,i)
-                rad_lw_net_u = rad_lw_in(k  ,j,i) - rad_lw_out(k  ,j,i)
-
-                tend(k,j,i) = tend(k,j,i) + ( rad_sw_net_u - rad_sw_net_l      &
-                                      + rad_lw_net_u - rad_lw_net_l ) /        &
-                                      ( dzw(k) * cp * rho_surface ) * pt_d_t(k) 
+                tend(k,j,i) = tend(k,j,i) + ( rad_lw_hr(k,j,i)                 &
+                                            +  rad_sw_hr(k,j,i) ) * pt_d_t(k)  &
+                                            * d_seconds_hour
              ENDDO
          ENDDO
Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 1686)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added output of radiative heating rates and Obukhov length. Removed output of
+! rif.
 ! 
 ! Former revisions:
@@ -83,6 +84,6 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, kh, km, p, pt, q, ql, qc, nr, nrs, nrsws, nrswst, qr, qrs,   &
-               qrsws, qrswst, qs, qsws, qswst, sa, saswsb, saswst, rif,        &
+        ONLY:  e, kh, km, ol, p, pt, q, ql, qc, nr, nrs, nrsws, nrswst, qr,    &
+               qrs, qrsws, qrswst, qs, qsws, qswst, sa, saswsb, saswst,        &
                rif_wall, shf, ts, tswst, u, u_m_l, u_m_n, u_m_r, u_m_s, us,    &
                usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, vsws, vswst,   &
@@ -119,5 +120,8 @@
     USE radiation_model_mod,                                                   &
         ONLY: rad_net, rad_net_av, rad_lw_in, rad_lw_in_av, rad_lw_out,        &
-              rad_lw_out_av, rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av
+              rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr, rad_lw_hr_av,          &
+              rad_lw_out_av, rad_sw_in, rad_sw_in_av, rad_sw_out,              &
+              rad_sw_out_av, rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr,         &
+              rad_sw_hr_av
 
     USE random_function_mod,                                                   &
@@ -595,4 +599,8 @@
                    nrswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
                                           tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                CASE ( 'ol' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   ol(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'p' )
@@ -867,4 +875,36 @@
                              tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+                CASE ( 'rad_lw_cs_hr' )
+                   IF ( .NOT. ALLOCATED( rad_lw_cs_hr ) )  THEN
+                      ALLOCATE( rad_lw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_lw_cs_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_lw_cs_hr_av' )
+                   IF ( .NOT. ALLOCATED( rad_lw_out_av ) )  THEN
+                      ALLOCATE( rad_lw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_lw_cs_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_lw_hr' )
+                   IF ( .NOT. ALLOCATED( rad_lw_hr ) )  THEN
+                      ALLOCATE( rad_lw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_lw_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_lw_hr_av' )
+                   IF ( .NOT. ALLOCATED( rad_lw_hr_av ) )  THEN
+                      ALLOCATE( rad_lw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_lw_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'rad_sw_in' )
                    IF ( .NOT. ALLOCATED( rad_sw_in ) )  THEN
@@ -898,4 +938,36 @@
                    rad_sw_out_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                              tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_sw_cs_hr' )
+                   IF ( .NOT. ALLOCATED( rad_sw_cs_hr ) )  THEN
+                      ALLOCATE( rad_sw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_sw_cs_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_sw_cs_hr_av' )
+                   IF ( .NOT. ALLOCATED( rad_sw_out_av ) )  THEN
+                      ALLOCATE( rad_sw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_sw_cs_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_sw_hr' )
+                   IF ( .NOT. ALLOCATED( rad_sw_hr ) )  THEN
+                      ALLOCATE( rad_sw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_sw_hr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'rad_sw_hr_av' )
+                   IF ( .NOT. ALLOCATED( rad_sw_hr_av ) )  THEN
+                      ALLOCATE( rad_sw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   rad_lw_hr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                           tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'random_iv' )  ! still unresolved issue
@@ -914,9 +986,4 @@
                    rho_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
                                 tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'rif' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   rif(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'rif_wall' )
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 1686)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
-! 
+! Added output of most_method, constant_flux_layer, zeta_min, zeta_max. Removed 
+! output of prandtl_layer and rif_min, rif_max.
 ! 
 ! Former revisions:
@@ -179,4 +180,5 @@
         ONLY:  statistic_regions, hom, hom_sum, pr_palm, u_max, u_max_ijk,     &
                v_max, v_max_ijk, w_max, w_max_ijk
+
 
     IMPLICIT NONE
@@ -356,4 +358,6 @@
           CASE ( 'conserve_volume_flow_mode' )
              READ ( 13 )  conserve_volume_flow_mode
+          CASE ( 'constant_flux_layer' )
+             READ ( 13 )  constant_flux_layer
           CASE ( 'coupling_start_time' )
              READ ( 13 )  coupling_start_time
@@ -460,4 +464,6 @@
           CASE ( 'momentum_advec' )
              READ ( 13 )  momentum_advec
+          CASE ( 'most_method' )
+             READ ( 13 )  most_method
           CASE ( 'nc_const' )
              READ ( 13 )  nc_const
@@ -494,6 +500,4 @@
           CASE ( 'phi' )
              READ ( 13 )  phi
-          CASE ( 'prandtl_layer' )
-             READ ( 13 )  prandtl_layer
           CASE ( 'prandtl_number' )
              READ ( 13 )  prandtl_number
@@ -552,8 +556,4 @@
           CASE ( 'residual_limit' )
              READ ( 13 )  residual_limit
-          CASE ( 'rif_max' )
-             READ ( 13 )  rif_max
-          CASE ( 'rif_min' )
-             READ ( 13 )  rif_min
           CASE ( 'roughness_length' )
              READ ( 13 )  roughness_length
@@ -714,4 +714,8 @@
           CASE ( 'w_max_ijk' )
              READ ( 13 )  w_max_ijk
+          CASE ( 'zeta_max' )
+             READ ( 13 )  zeta_max
+          CASE ( 'zeta_min' )
+             READ ( 13 )  zeta_min
           CASE ( 'z0h_factor' )
              READ ( 13 )  z0h_factor
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1686)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added output of Obukhov length and radiative heating rates for RRTMG. 
+! Corrected output of LWC.
 ! 
 ! Former revisions:
@@ -84,9 +85,9 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  dzw, e, nr, p, pt, q, qc, ql, ql_c, ql_v, qr, qsws, rho, sa,    &
+        ONLY:  dzw, e, nr, ol, p, pt, q, qc, ql, ql_c, ql_v, qr, qsws, rho, sa,&
                shf, ts, u, us, v, vpt, w, z0, z0h
 
     USE averaging,                                                             &
-        ONLY:  e_av, lpt_av, lwp_av, nr_av, p_av, pc_av, pr_av, prr_av,        &
+        ONLY:  e_av, lpt_av, lwp_av, nr_av, ol_av, p_av, pc_av, pr_av, prr_av, &
                precipitation_rate_av, pt_av, q_av, qc_av, ql_av, ql_c_av,      &
                ql_v_av, ql_vp_av, qr_av, qsws_av, qv_av, rho_av, s_av, sa_av,  &
@@ -97,5 +98,5 @@
 
     USE control_parameters,                                                    &
-        ONLY:  average_count_3d, cloud_physics, doav, doav_n
+        ONLY:  average_count_3d, cloud_physics, doav, doav_n, rho_surface
 
     USE cpulog,                                                                &
@@ -120,6 +121,9 @@
     USE radiation_model_mod,                                                   &
         ONLY:  rad_net, rad_net_av, rad_sw_in, rad_sw_in_av, rad_sw_out,       &
-               rad_sw_out_av, rad_lw_in, rad_lw_in_av, rad_lw_out,             &
-               rad_lw_out_av
+               rad_sw_out_av, rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr,        &
+               rad_sw_hr_av, rad_lw_in, rad_lw_in_av, rad_lw_out,              &
+               rad_lw_out_av, rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr,        &
+               rad_lw_hr_av
+
 
     IMPLICIT NONE
@@ -215,4 +219,10 @@
                 nr_av = 0.0_wp
 
+             CASE ( 'ol*' )
+                IF ( .NOT. ALLOCATED( ol_av ) )  THEN
+                   ALLOCATE( ol_av(nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                ol_av = 0.0_wp
+
              CASE ( 'p' )
                 IF ( .NOT. ALLOCATED( p_av ) )  THEN
@@ -347,4 +357,16 @@
                 rad_lw_out_av = 0.0_wp
 
+             CASE ( 'rad_lw_cs_hr' )
+                IF ( .NOT. ALLOCATED( rad_lw_cs_hr_av ) )  THEN
+                   ALLOCATE( rad_lw_cs_hr_av(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                rad_lw_cs_hr_av = 0.0_wp
+
+             CASE ( 'rad_lw_hr' )
+                IF ( .NOT. ALLOCATED( rad_lw_hr_av ) )  THEN
+                   ALLOCATE( rad_lw_hr_av(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                rad_lw_hr_av = 0.0_wp
+
              CASE ( 'rad_sw_in' )
                 IF ( .NOT. ALLOCATED( rad_sw_in_av ) )  THEN
@@ -359,4 +381,16 @@
                 rad_sw_out_av = 0.0_wp
 
+             CASE ( 'rad_sw_cs_hr' )
+                IF ( .NOT. ALLOCATED( rad_sw_cs_hr_av ) )  THEN
+                   ALLOCATE( rad_sw_cs_hr_av(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                rad_sw_cs_hr_av = 0.0_wp
+
+             CASE ( 'rad_sw_hr' )
+                IF ( .NOT. ALLOCATED( rad_sw_hr_av ) )  THEN
+                   ALLOCATE( rad_sw_hr_av(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                rad_sw_hr_av = 0.0_wp
+
              CASE ( 'rho' )
                 IF ( .NOT. ALLOCATED( rho_av ) )  THEN
@@ -530,6 +564,6 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   lwp_av(j,i) = lwp_av(j,i) + SUM( ql(nzb:nzt,j,i) * &
-                                                    dzw(1:nzt+1) )
+                   lwp_av(j,i) = lwp_av(j,i) + SUM( ql(nzb:nzt,j,i)            &
+                                               * dzw(1:nzt+1) ) * rho_surface
                 ENDDO
              ENDDO
@@ -557,4 +591,11 @@
                       nr_av(k,j,i) = nr_av(k,j,i) + nr(k,j,i)
                    ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'ol*' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   ol_av(j,i) = ol_av(j,i) + ol(j,i)
                 ENDDO
              ENDDO
@@ -777,4 +818,21 @@
              ENDDO
 
+          CASE ( 'rad_lw_cs_hr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_lw_cs_hr_av(k,j,i) = rad_lw_cs_hr_av(k,j,i) + rad_lw_cs_hr(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_lw_hr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_lw_hr_av(k,j,i) = rad_lw_hr_av(k,j,i) + rad_lw_hr(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'rad_sw_in' )
@@ -792,4 +850,22 @@
                    DO  k = nzb, nzt+1
                       rad_sw_out_av(k,j,i) = rad_sw_out_av(k,j,i) + rad_sw_out(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_sw_cs_hr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_sw_cs_hr_av(k,j,i) = rad_sw_cs_hr_av(k,j,i) + rad_sw_cs_hr(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_sw_hr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_sw_hr_av(k,j,i) = rad_sw_hr_av(k,j,i) + rad_sw_hr(k,j,i)
                    ENDDO
                 ENDDO
